#COMPILE EXE "ObjReader.exe"

#INCLUDE "Windows.inc"
#INCLUDE "WinLIFT.inc"

#RESOURCE "objreader.pbr"

%ClientW       = 1166
%ClientH       = 600
%MenuHeight    = 20

%MENU_FILE_OPEN          = 40004
%MENU_ABOUT              = 40005
%MENU_FILE_EXIT          = 40006
%MENU_VIEW_FULLSCREEN    = 40012
%MENU_VIEW_RESET         = 40013
%MENU_VIEW_TEXTURED      = 40014
%MENU_VIEW_WIREFRAME     = 40015
%MENU_VIEW_CLOUD         = 40016
%MENU_VIEW_MIPMAP        = 40017
%MENU_VIEW_CULLBACKFACES = 40018
%MENU_SMOOTH_ZOOMING     = 40019
%MENU_SPECULAR_MODE      = 40020
%MENU_FIXED_PIPELINE     = 40022
%MENU_SWAP_VECTOR        = 40024
%MENU_SWAP_WINDING       = 40025
%MENU_BRIGHT_LIGHT       = 40026
%MENU_WALLPAPER          = 40028
%MENU_PRINT              = 40029
%MENU_ALPHA_TO_COVERAGE  = 40030

function WndProc(byval hWnd as dword, byval uMsg as dword, byval wParam as dword, byval lParam as long) as long
    function = DefWindowProc(hWnd, uMsg, wParam, lParam)
end function

function WinMain (byval hInstance as dword, byval hPrevInstance as dword, byval lpszCmdLine as asciiz ptr, byval nCmdShow as long) as long
    local Msg as tagMsg

    local zClass as asciiz * 16: zClass = "WavefrontOBJ"
    local szCaption as asciiz * %MAX_PATH

    local nRet as long
    local wcx as WndClassEx

    wcx.cbSize = sizeof(wcx)
    local IsInitialized as long: IsInitialized = GetClassInfoEx(GetModuleHandle(""), zClass, wcx)
    if (not IsInitialized) then
        wcx.style         = %CS_HREDRAW or %CS_VREDRAW
        wcx.lpfnWndProc   = codeptr(WndProc)
        wcx.cbClsExtra    = 0
        wcx.cbWndExtra    = 0
        wcx.hInstance     = hinstance
        wcx.hIcon         = LoadIcon(wcx.hInstance, "PROGRAM")
        wcx.hCursor       = LoadCursor(%NULL, byval %IDC_ARROW)
        wcx.hbrBackground = %COLOR_BTNSHADOW
        wcx.lpszMenuName  = %NULL
        wcx.lpszClassName = varptr(zClass)
        wcx.hIconSm       = wcx.hIcon
        if (RegisterClassEx(wcx)) then IsInitialized = %TRUE
    end if

    if (IsInitialized) then
        local dwStyle as dword: dwStyle = %WS_OVERLAPPEDWINDOW or %WS_CLIPSIBLINGS or %WS_CLIPCHILDREN
        local dwExStyle as dword: dwExStyle = %WS_EX_APPWINDOW or %WS_EX_WINDOWEDGE
        local rc as RECT
        SetRect(rc, 0, 0, %ClientW, %ClientH + %MenuHeight)
        AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window to True Requested Size
        local minTrackSizeW, minTrackSizeH as long
        minTrackSizeW = rc.nRight - rc.nLeft
        minTrackSizeH = rc.nBottom - rc.nTop
        local x as long: x = max&((GetSystemMetrics(%SM_CXSCREEN) - minTrackSizeW) \ 2, 0)
        local y as long: y = max&((GetSystemMetrics(%SM_CYSCREEN) - minTrackSizeH) \ 2, 0)

        '// Create The Window
        local hMain as dword
        szCaption = "ObjReader 32-bit"
        hMain = CreateWindowEx(dwExStyle, zClass, szCaption, dwStyle, x, y, minTrackSizeW, minTrackSizeH, 0, 0, hinstance, byval %NULL)
        if (hMain) then

            local hCtrl as dword

                local hMnu, hSubMenu as dword
                hMnu = CreateMenu()
                hSubMenu = CreatePopupMenu()
                AppendMenu(hMnu, %MF_POPUP or %MF_ENABLED, hSubMenu, "File")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_FILE_OPEN, "Open...")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_ABOUT, "About")
                AppendMenu(hSubMenu, %MF_SEPARATOR, 0, "")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_FILE_EXIT, "Exit")
                hSubMenu = CreatePopupMenu()
                AppendMenu(hMnu, %MF_POPUP or %MF_ENABLED, hSubMenu, "View")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_VIEW_FULLSCREEN, "Fullscreen")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_VIEW_RESET, "Reset")

                AppendMenu(hSubMenu, %MF_SEPARATOR, 0, "")

                AppendMenu(hSubMenu, %MF_CHECKED, %MENU_FIXED_PIPELINE, "Use fixed pipeline")

                AppendMenu(hSubMenu, %MF_SEPARATOR, 0, "")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_VIEW_TEXTURED, "Textured")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_VIEW_WIREFRAME, "Wireframe")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_VIEW_CLOUD, "Point cloud")
                dwStyle = %MF_ENABLED
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_SPECULAR_MODE, "Ambient reflection")

                AppendMenu(hSubMenu, %MF_SEPARATOR, 0, "")
                dwStyle = %MF_ENABLED
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_VIEW_MIPMAP, "Mipmap textures")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_BRIGHT_LIGHT, "Multiple light sources")

                AppendMenu(hSubMenu, %MF_SEPARATOR, 0, "")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_ALPHA_TO_COVERAGE, "Alpha to coverage")

                AppendMenu(hSubMenu, %MF_SEPARATOR, 0, "")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_VIEW_CULLBACKFACES, "Cull back faces")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_SWAP_VECTOR, "Swap Y,Z axes")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_SWAP_WINDING, "Swap polygon winding order")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_SMOOTH_ZOOMING, "Smooth zooming")

                AppendMenu(hSubMenu, %MF_SEPARATOR, 0, "")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_WALLPAPER, "Save to image")
                AppendMenu(hSubMenu, %MF_ENABLED, %MENU_PRINT, "Print image")

                SetMenu (hMain, hMnu)

                if (skInitEngine("Reader32.sks", "")) then
                    skSkinWindow(hMain, "Dock|Undock|Minimize|Maximize|Restore|Close")
                end if

                '// Show the main window
                ShowWindow(hMain, nCmdShow)
                SetForegroundWindow(hMain)
                SetFocus(hMain)

                '// Main message pump.
                while GetMessage(Msg, 0, 0, 0)
                      TranslateMessage(Msg)
                      DispatchMessage(Msg)
                wend

                nRet = msg.wParam
        end if
    end if

    function = nRet
end function
