#COMPILE DLL "WinLIFT.dll"

$Version = "WinLIFT 4.92"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

#INCLUDE "API.inc"
#INCLUDE "WinLIFT.INC"

'/////////////////////////////////////////////////////////////////

%gIDseed            = 65000

TYPE MENUITEMS
    hParentMenu   AS DWORD
    mii           AS MENUITEMINFO
    gzCap         AS ASCIIZ * 260
END TYPE

TYPE MAINPROPERTY
    hWnd             AS LONG
    StyleEx          AS LONG
    Style            AS LONG
    PrevProc         AS DWORD
    WindowState      AS LONG
    WasButton        AS LONG
    hMenu            AS LONG
END TYPE

GLOBAL g_mi() AS MENUITEMS, g_Win() AS MAINPROPERTY
GLOBAL g_mSkin(), g_MiCount, g_ID AS LONG

'// 4.80
SUB skSetLabelFont ALIAS "skSetLabelFont" (BYVAL hCtrl AS LONG, zFontName AS ASCIIZ, BYVAL nFontSize AS WORD, BYVAL ARGBcolor AS LONG, BYVAL nFontStyle AS WORD) EXPORT
END SUB

FUNCTION CheckStyle(BYVAL nMainStyle AS LONG, BYVAL nStyleToCheck AS LONG) AS LONG
    IF (nMainStyle AND nStyleToCheck) = nStyleToCheck THEN FUNCTION = -1
END FUNCTION

FUNCTION CheckWindowStyle(BYVAL hWnd AS LONG, BYVAL nStyle AS LONG) AS LONG
    IF (GetWindowLong(hWnd, %GWL_STYLE) AND nStyle) = nStyle THEN FUNCTION = -1
END FUNCTION

FUNCTION CheckWindowExStyle(BYVAL hWnd AS LONG, BYVAL nStyle AS LONG) AS LONG
    IF (GetWindowLong(hWnd, %GWL_EXSTYLE) AND nStyle) = nStyle THEN FUNCTION = -1
END FUNCTION

FUNCTION skVersion ALIAS "skVersion" () EXPORT AS STRING
    FUNCTION = $Version
END FUNCTION

''// Set control z-order
SUB skSetZorder ALIAS "skSetZorder" (BYVAL hWnd AS LONG, BYVAL UseOrder AS LONG) EXPORT
END SUB

'// 4.89 Main window minimum horizontal track size
FUNCTION MinTrackSizeX ALIAS "MinTrackSizeX"(BYVAL SizeX AS LONG) EXPORT AS LONG
END FUNCTION

'// 4.89 Main window minimum vertical track size
FUNCTION MinTrackSizeY ALIAS "MinTrackSizeY"(BYVAL SizeY AS LONG) EXPORT AS LONG
END FUNCTION

'// To check KEY or MOUSE button state.
FUNCTION IsKeyDown (BYVAL CheckKey AS LONG) AS LONG
    LOCAL KeyDown AS LONG
    KeyDown = GetAsyncKeyState(CheckKey)
    FUNCTION = BIT(KeyDown, 15)
END FUNCTION

'// To check the left mouse button state.
FUNCTION IsLButtonDown () AS LONG
    FUNCTION = IsKeyDown(1)
END FUNCTION

FUNCTION skPopupOwner ALIAS "skPopupOwner" (BYVAL hWnd AS LONG) EXPORT AS LONG
    LOCAL hParent AS LONG
    IF hWnd THEN
       IF skItem(hWnd) THEN
          FUNCTION = hWnd
       ELSE
          DO
              hParent = GetParent(hWnd)
              IF hParent = 0 THEN hParent = hWnd: EXIT DO
              IF CheckWindowStyle(hParent, %WS_POPUP) THEN EXIT DO
              hWnd = hParent
          LOOP
          FUNCTION = hParent
       END IF
    END IF
END FUNCTION

' Compute offset to paint skin background behind a control
SUB skChildOffset ALIAS "skChildOffset" (BYVAL hWnd AS LONG, BYREF ofX AS LONG, BYREF ofY AS LONG) EXPORT
    LOCAL p  AS POINTAPI, rw AS RECT
    p.X = 0: p.Y = 0:  ClientToScreen(hWnd, p)
     GetWindowRect(skPopupOwner(hWnd), rw)
    ofX = p.X - rw.nLeft: ofY = p.Y - rw.nTop
END SUB

FUNCTION skCaptionFont ALIAS "skCaptionFont" () EXPORT AS LONG
END FUNCTION

FUNCTION skFont ALIAS "skFont" () EXPORT AS LONG
END FUNCTION

FUNCTION skFontBold ALIAS "skFontBold" () EXPORT AS LONG
END FUNCTION

FUNCTION skFontDlg ALIAS "skFontDlg" () EXPORT AS LONG
END FUNCTION

' Font to use in menu
FUNCTION skFontMenu() AS LONG
    STATIC hTrebuchet AS LONG
    LOCAL sUseFont AS STRING
    IF hTrebuchet = 0 THEN
       DIM LF AS LogFont
       LF.lfHeight         = -12'-13'1'-16
       LF.lfWidth          = 0
       LF.lfCharSet        = 1 '%DEFAULT_CHARSET
       LF.lfOutPrecision   = 6'0'%OUT_DEFAULT_PRECIS
       LF.lfClipPrecision  = 0'%OUT_DEFAULT_PRECIS
       LF.lfQuality        = 0'5'CLEAR_TYPE
       LF.lfPitchAndFamily = 0' %DEFAULT_PITCH OR %FF_DONTCARE
       sUseFont = "Trebuchet MS"
       LF.lfFaceName       = sUseFont
       LF.lfWeight         = 800'700
       hTrebuchet = CreateFontIndirect(LF)
    END IF
    FUNCTION = hTrebuchet
END FUNCTION

' Retrieves the DC of a memory bitmap
FUNCTION skGetHdcMemBmp ALIAS "skGetHdcMemBmp" (BYVAL hOwner AS LONG) EXPORT AS LONG
END FUNCTION

' Detect OS version
FUNCTION skOsVersion () AS LONG

    DIM os AS OSVERSIONINFO

    os.dwOSVersionInfoSize = SIZEOF(os)

    IF GetVersionEx(os) THEN

       SELECT CASE LONG os.dwPlatformId
       CASE 1
            FUNCTION = os.dwPlatformId
            IF os.dwMinorVersion = 0 THEN
               FUNCTION = 95  ' "Windows 95"
            ELSEIF os.dwMinorVersion = 10 THEN
               FUNCTION = 98  ' "Windows 98"
            ELSEIF os.dwMinorVersion = 90 THEN
               FUNCTION = 100 ' "Windows ME"
            END IF
       CASE 2
            FUNCTION = os.dwPlatformId
            IF os.dwMajorVersion = 3 THEN
               FUNCTION = 351 ' "Windows NT 3.51"
            ELSEIF os.dwMajorVersion = 4 THEN
               FUNCTION = 400 ' "Windows NT 4.0"
            ELSEIF os.dwMajorVersion = 5 THEN
               FUNCTION = 500 ' "Windows 2000"
               IF os.dwMinorVersion = 1 THEN
                  FUNCTION = 501 ' "Windows XP"
               END IF
            ELSEIF os.dwMajorVersion = 6 THEN
               FUNCTION = 600 ' "Windows VISTA"
            END IF
       CASE ELSE
            FUNCTION = -1     ' "Unknown"
       END SELECT
    ELSE
       FUNCTION = 0           ' "Failed"
    END IF

END FUNCTION

'// Anchor CTRL properties setup.
FUNCTION skSetAnchorCtrl ALIAS "skSetAnchorCtrl" (BYVAL hWnd AS LONG, BYVAL AnchorMode AS LONG) EXPORT AS LONG
END FUNCTION

FUNCTION skDisplayDC() AS LONG
    FUNCTION = CreateIC ("DISPLAY", BYVAL %NULL, BYVAL %NULL, BYVAL %NULL)
END FUNCTION

FUNCTION skCreateDIBSection ALIAS "skCreateDIBSection" (BYVAL hDC AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL BitCount AS LONG) AS LONG
END FUNCTION

FUNCTION skARGB ALIAS "skARGB" (BYVAL A AS BYTE, BYVAL R AS BYTE, BYVAL G AS BYTE, BYVAL B AS BYTE) EXPORT AS LONG
END FUNCTION

'//4.86 Retrieves all system metrics for a specific Skin.
FUNCTION skGetSystemMetrics ALIAS "skGetSystemMetrics" (BYVAL nMeasure AS LONG) EXPORT AS LONG
END FUNCTION

FUNCTION skItem(BYVAL hWnd AS LONG) AS LONG
    LOCAL nItem AS LONG
    IF UBOUND(g_Win) > 0 THEN
       ARRAY SCAN g_Win(), FROM 1 TO 4, = MKL$(hWnd), TO nItem
    END IF
    FUNCTION = nItem
END FUNCTION

'// This function is being used by GDImage to detect the DWM status.
FUNCTION skUsingDWM ALIAS "skUsingDWM" () EXPORT AS LONG
END FUNCTION

FUNCTION skSkinFolder ALIAS "skSkinFolder" () EXPORT AS STRING
END FUNCTION

' Returns the "Skin" author name and copyright.
FUNCTION skAuthor ALIAS "skAuthor" () EXPORT AS STRING
END FUNCTION

FUNCTION LIBMAIN (BYVAL hInstance AS DWORD, BYVAL fwdReason AS LONG, BYVAL lpvReserved AS LONG) EXPORT AS LONG

    SELECT CASE AS LONG fwdReason
    CASE %DLL_PROCESS_ATTACH
 
    CASE %DLL_PROCESS_DETACH

    END SELECT

    FUNCTION = %TRUE

END FUNCTION

' Returns string width and height in pixels based on a specific formated font.
SUB skGetFullTextExtent (BYVAL hWnd AS LONG, BYVAL hFont AS LONG, BYVAL sText AS STRING, BYREF nW AS LONG, BYREF nH AS LONG)

    LOCAl rc AS RECT, hDC, OldDC AS LONG

    IF hWnd THEN
       hDC = GetDC(hWnd)
    ELSE
       hDC = skDisplayDC
    END IF
    OldDC = SelectObject(hDC, hFont)

    DrawTextEx(hDC, (sText), LEN(sText), rc, %DT_CALCRECT OR %DT_EXPANDTABS, BYVAL %NULL)
    nW = rc.nRight - rc.nLeft
    nH = rc.nBottom - rc.nTop

    IF OldDC THEN SelectObject(hDC, OldDC)
    IF hWnd THEN
        ReleaseDC(hWnd, hDC)
    ELSE
        DeleteDC(hDC)
    END IF

END SUB

FUNCTION skBorder ALIAS "skBorder" (BYVAL hWnd AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL nID AS LONG, BYVAL nBorder AS LONG) EXPORT AS LONG
END FUNCTION

' Disable skinning of a specific control
FUNCTION skSkinDisable ALIAS "skSkinDisable" (BYVAL hWnd AS LONG) EXPORT AS LONG
END FUNCTION

' Enable skinning of a specific control (after a previous  to skSkinDisable)
FUNCTION skSkinEnable ALIAS "skSkinEnable" (BYVAL hWnd AS LONG) EXPORT AS LONG
END FUNCTION

' Redraws the menu bar of the specified window when the item content has changed
' DON'T REMOVE THIS ONE!
SUB skRedrawMenuBar ALIAS "skRedrawMenuBar" (BYVAL hWnd AS LONG) EXPORT
END SUB

FUNCTION skGetMenu ALIAS "skGetMenu" (BYVAL hWnd AS LONG) EXPORT AS LONG
END FUNCTION

FUNCTION skMenuContainer ALIAS "skMenuContainer" (BYVAL hWnd AS LONG) EXPORT AS LONG
END FUNCTION

FUNCTION skInitEngine ALIAS "skInitEngine"(zSkinFile AS ASCIIZ, zUserKey AS ASCIIZ) EXPORT AS LONG
    FUNCTION = -1
END FUNCTION

FUNCTION skMenuSkinItemOk (BYVAL nID AS LONG) AS LONG
    LOCAL nItem AS LONG
    IF UBOUND(g_mSkin) > 0 THEN ARRAY SCAN g_mSkin(), = nID, TO nItem
    FUNCTION = nItem
END FUNCTION

FUNCTION skMenuItem (BYVAL ItemID AS LONG) AS LONG
    LOCAL nItem AS LONG
    ARRAY SCAN g_mi(), FROM 21 TO 24, = MKDWD$(ItemID), TO nItem
    FUNCTION = nItem - 1
END FUNCTION

' Do recursive menu grabbing
function MenuDoRecurse (byval hWnd as dword, byval hMenu as dword) as dword

    local c, wID, cxCheck, itemWidth, itemHeight, MaxWidth, SkinIt, DoIt, skit, nBound as long
    local sItem as string
    local zTxt as asciiz * 260

    MaxWidth = 0
    for c = GetMenuItemCount(hMenu) - 1 to 0 step - 1 '// Case ALT+F4 on task bar

       if g_MiCount MOD 10 = 0 then redim preserve g_mi(g_MiCount + 10)

       '// Read section
       g_mi(g_MiCount).hParentMenu    = hMenu
       g_mi(g_MiCount).mii.cbSize     = sizeof(MENUITEMINFO)
       g_mi(g_MiCount).mii.fMask      = %MIIM_STATE or %MIIM_ID or %MIIM_SUBMENU or _
                                     %MIIM_CHECKMARKS or %MIIM_TYPE or %MIIM_DATA

       GetMenuItemInfo(hMenu, c, 1, g_mi(g_MiCount).mii)
       wID = g_mi(g_MiCount).mii.wID

       GetMenuString(hMenu, c, zTxt, sizeof(zTxt), %MF_BYPOSITION)
zTrace("--01")
       poke$ varptr(g_mi(g_MiCount).gzCap), LEFT$(zTxt, sizeof(g_mi(g_MiCount).gzCap))
zTrace("--02")
       '// Warning DDT doesn't set the wID for "menu bar items"
       if len(zTxt) and wID = 0 then
          incr g_ID: wID = g_ID
       end if

       DoIt = 0
       if CheckStyle(g_mi(g_MiCount).mii.fType, %MFT_OWNERDRAW) = 0 then DoIt = -1
       '// Always skin menu bar items
       nBound = skItem(skPopupOwner(hWnd))
       if nBound > 0 then
          if hMenu = GetMenu(g_Win(nBound).hMenu) then DoIt = -1
       end if
       if DoIt then
          '// Do it only if the skin flag is not been set already
zTrace("--03")
          if skMenuSkinItemOk(wID) = 0 then
             skit = max&(ubound(g_mSkin) + 1, 1)
zTrace(str$(skit))
             redim preserve g_mSkin(1 to skit)
             g_mSkin(skit) = wID
          end if
zTrace("--04")
       end if
zTrace("--04-01 by me this is where it GPF")
       SkinIt = skMenuSkinItemOk(wID)
zTrace("--04-02")
       '// Write section
       g_mi(g_MiCount).mii.cbSize = sizeof(MENUITEMINFO)
       g_mi(g_MiCount).mii.fMask  = %MIIM_FTYPE or %MIIM_DATA or %MIIM_ID

zTrace("--05")
       if SkinIt then g_mi(g_MiCount).mii.fType = %MFT_OWNERDRAW
zTrace("--06")

       sItem = zTxt
       if len(sItem) = 0 then
          sItem = "-"
          g_mi(g_MiCount).mii.fType = %MFT_OWNERDRAW or %MFT_SEPARATOR
       end if
       skGetFullTextExtent(0, skFontMenu(), sItem, itemWidth, itemHeight)
       sItem = zTxt

       if instr(sItem, chr$(9)) then
          if skOsVersion() > 499 then itemWidth += 15 ELSE itemWidth -= 25
       end if

zTrace("--07")
       if hMenu <> GetMenu(hWnd) then
          cxCheck = GetSystemMetrics(%SM_CXMENUCHECK) * 2 + 6
          itemWidth += cxCheck

          MaxWidth = MAX(MaxWidth, itemWidth): itemWidth = MaxWidth ' Case ALT+F4 on task bar

       end if
       itemHeight += 3
zTrace("--08")
       if SkinIt then
          g_mi(g_MiCount).mii.dwItemData = MAKDWD(itemWidth, itemHeight)
       end if

       g_mi(g_MiCount).mii.wID = wID
zTrace("--09")
       SetMenuItemInfo(hMenu, c, 1, g_mi(g_MiCount).mii)
zTrace("--10")
       incr g_MiCount

       if g_mi(g_MiCount - 1).mii.hSubMenu then                  '// if an item has a submenu,
zTrace("--avant")
           MenuDoRecurse(hWnd, g_mi(g_MiCount - 1).mii.hSubMenu) '// do recursive  to grab all submenu items
zTrace("--apres")
       end if
    next
zTrace("--fin")
end function

' Start recursive menu grabbing
function MenuStartRecurse (byval hWnd as dword) as dword

    local hMenu as dword

    hMenu = GetMenu(hWnd)
    if hMenu then
       redim g_mi(0): g_MiCount = 0
       MenuDoRecurse(hWnd, hMenu)
       if g_MiCount then redim preserve g_mi(g_MiCount - 1)
    end if

end function

FUNCTION skSkinWindow ALIAS "skSkinWindow" (BYVAL hWnd AS LONG, zSysButTip AS ASCIIZ) EXPORT AS LONG

    LOCAL rw AS RECT
    LOCAL rc AS RECT
    LOCAL zTxt AS ASCIIZ * %MAX_PATH
    LOCAL T, K, hRgn, nItem, WasStyle, WasStyleEx, NewStyle, NewStyleEx, WasMenu, ClassStyle AS LONG
    LOCAL nT, nC, bmW, bmH, nDeltaY, hButton AS LONG

    FUNCTION = %FALSE

    WasStyle = GetWindowLong(hWnd, %GWL_STYLE)
    IF WasStyle THEN

       GetClassName(hWnd, zTxt, SIZEOF(zTxt))
       ClassStyle = GetClassLong(hWnd, %GCL_STYLE)
       WasStyleEx = GetWindowLong(hWnd, %GWL_EXSTYLE)

       GetWindowRect(hWnd, rw)
       GetClientRect(hWnd, rc)

       nItem = MAX&(UBOUND(g_Win) + 1, 1)
       REDIM PRESERVE g_Win(1 TO nItem) ' AS MAINPROPERTY
       g_Win(nItem).hWnd     = hWnd
       g_Win(nItem).StyleEx  = WasStyleEx
       g_Win(nItem).Style = WasStyle

     ' Tell the engine this window is the main skinned window frame.
       LOCAL hParent AS DWORD
       hParent = GetParent(hWnd)
       IF hParent = 0 OR skItem(skPopupOwner(hParent)) = 0 THEN
          WasMenu = GetMenu(hWnd)
          g_Win(nItem).hMenu = WasMenu
          IF WasMenu THEN
           ' Make sure there is only plain text on the menu bar (needed this for MixMenu)
             FOR K = 0 TO GetMenuItemCount(WasMenu) - 1
                 GetMenuString(WasMenu, K, zTxt, SIZEOF(zTxt), %MF_BYPOSITION)
                 UseFlag& = %MF_BYPOSITION
                 Mflag& = GetMenuState(WasMenu, K, %MF_BYPOSITION)
                 IF CheckStyle(Mflag&, %MF_GRAYED) THEN UseFlag& = UseFlag& OR %MF_GRAYED
                 ModifyMenu(WasMenu, K, UseFlag&, 0, zTxt)
             NEXT
           ' DDT doesn't set the wID for "menu bar items" causing havoc with ownerdrawn menu.
             g_ID = %gIDseed
             MenuStartRecurse(hWnd)
             SetMenu(hWnd, 0) ' Clear the menu
          END IF
       END IF

       FUNCTION = %TRUE
    END IF

END FUNCTION
